@import "../core/pallete.pcss";
@import "../core/typography.pcss";
@import "../core/variables.pcss";

:root {
  --button-min-width: 100px;
  --button-height: 32px;
  --button-padding: 0 20px;

  --button-border-width: 1px;
  --button-border-color: transparent;
  --button-radius: 20px;

  --button-text-color: var(--color-white);
  --button-text-weight: var(--text-font-weight-medium);

  --button-background-color: var(--color-secondary);
  --button-background-image: linear-gradient(-43deg, #e83f94 0%, #f54e5e 100%);
  --button-background-image-hover: linear-gradient(43deg, #e83f94 0%, #f54e5e 100%);
  --button-background-image-active: linear-gradient(43deg, #e8338e 0%, #f53650 100%);

  --button-icon-max-size: 14px;
}

/* stylelint-disable */
@mixin button-reset() {
  padding: 0;
  border: 0;
  background: none;

  &:focus {
    outline: none;
  }
}
/* stylelint-enable */

.button {
  display: inline-flex;
  justify-content: center;
  align-items: center;

  min-width: var(--button-min-width);
  max-width: 100%;
  height: var(--button-height);
  padding: var(--button-padding);

  position: relative;

  border: var(--button-border-width) solid var(--button-border-color);
  border-radius: var(--button-radius);

  background-color: var(--button-background-color);
  background-image: var(--button-background-image);

  font-weight: var(--button-text-weight);
  text-align: center;
  text-decoration: none;
  color: var(--button-text-color);

  transition: all .3s ease;
  cursor: pointer;
  z-index: var(--z-index-button);
  overflow: hidden;

  text-transform: uppercase;
  letter-spacing: .8px;

  touch-action: manipulation;
  user-select: none;
  -webkit-appearance: inherit;

  &:focus {
    outline: none;
  }

  &:hover,
  &:focus {
    background-image: var(--button-background-image-hover);
    text-decoration: none;
    color: var(--button-text-color);
  }

  &:active {
    background-image: var(--button-background-image-active);
  }
}

.button__text {
  line-height: 2;
  color: currentColor;
  overflow: hidden;
  white-space: nowrap;
  text-overflow: ellipsis;
}

.button__icon {
  max-width: var(--button-icon-max-size);
  max-height: var(--button-icon-max-size);

  + .button__text {
    margin-left: 5px;
  }
}

.button--blue {
  background: var(--color-main);

  &:hover,
  &:focus {
    background: color(var(--color-main) shade(10%));
  }

  &:active {
    background: color(var(--color-main) shade(20%));
  }
}

/* disabled styles */
.button--disabled,
.button[disabled],
fieldset[disabled] .button {
  box-shadow: none;
  cursor: not-allowed;
  opacity: .32;
  pointer-events: none;
}

button[type = "button"] {
  cursor: pointer;
}

/* Compact button */

:root {
  --button-max-size: 16px;
  --button-icon-max-size: 12px;
}

.button-compact {
  display: inline-flex;
  justify-content: center;
  align-items: center;
  width: var(--button-max-size);
  height: var(--button-max-size);
  text-decoration: none;
  color: var(--color-main-dark);
  cursor: pointer;
  /* stylelint-disable */
  @include button-reset();
  /* stylelint-enable*/

  &:hover {
    color: var(--color-secondary);
  }

  &:active {
    color: color(var(--color-secondary) shade(10%));
  }

  .icon {
    max-width: var(--button-icon-max-size);
    max-height: var(--button-icon-max-size);

    &.icon-upload {
      max-width: 16px;
      max-height: 16px;
    }
  }
}
/* end compact button */

/* Small round button */

:root {
  --button-width-small-round: 32px;
  --button-radius-small-round: 50%;
}

.button--round {
  width: var(--button-width-small-round);
  min-width: 0;
  padding: 0;
  border-radius: var(--button-radius-small-round);

  @media (--breakpoint-phone-max) {
    width: 24px;
    height: 24px;
  }
}
/* end small round button */
